
var renderClass = "jp.ngt.rtm.render.VehiclePartsRenderer";
importPackage(Packages.org.lwjgl.opengl);
importPackage(Packages.jp.ngt.rtm.render);
importPackage(Packages.jp.ngt.ngtlib.math);
importPackage(Packages.jp.ngt.rtm)
importPackage(Packages.jp.ngt.rtm.entity.train.util);
importPackage(Packages.jp.ngt.ngtlib.io);
importPackage(Packages.jp.ngt.rtm.entity.vehicle);
importPackage(Packages.jp.ngt.ngtlib.util);
importPackage(Packages.jp.ngt.ngtlib.renderer);
//データ保存処理(グローバル関数)
var LocalData = new java.util.HashMap();

//=== オブジェクト定義 ===
function init(par1, par2) {
    //車体
    body = renderer.registerParts(new Parts("body", "parts", "parts-s", "tesuri", "rubber", "jumper", "hose", "cable", "yaneue", "int", "under"));//車体

    //ヘッドマーク
    //1END
    HM10 = renderer.registerParts(new Parts("1HM0"));//無し
    HM11 = renderer.registerParts(new Parts("1HM1"));//飲酒
    HM12 = renderer.registerParts(new Parts("1HM2"));//150周年
    //2END
    HM20 = renderer.registerParts(new Parts("2HM0"));//無し
    HM21 = renderer.registerParts(new Parts("2HM1"));//飲酒
    HM22 = renderer.registerParts(new Parts("2HM2"));//150周年

    //灯具類
    F_Fon = renderer.registerParts(new Parts("Flight_Fon"));//前方前照灯点灯
    F_Fof = renderer.registerParts(new Parts("Flight_Fof"));//前方前照灯消灯
    F_Bon = renderer.registerParts(new Parts("Flight_Bon"));//前方尾灯点灯
    F_Bof = renderer.registerParts(new Parts("Flight_Bof"));//前方尾灯消灯
    ire = renderer.registerParts(new Parts("ire"));//入換灯点灯

    B_Fon = renderer.registerParts(new Parts("Blight_Fon"));//後方前照灯点灯
    B_Fof = renderer.registerParts(new Parts("Blight_Fof"));//後方前照灯消灯
    B_Bon = renderer.registerParts(new Parts("Blight_Bon"));//後方尾灯点灯
    B_Bof = renderer.registerParts(new Parts("Blight_Bof"));//後方尾灯消灯

    //台車
    bogieF = renderer.registerParts(new Parts("F-DT138")); //前台車
    bogieM = renderer.registerParts(new Parts("M-DT138")); //中台車
    bogieB = renderer.registerParts(new Parts("B-DT138")); //後台車
    wheelF1 = renderer.registerParts(new Parts("WF1")); //1軸
    wheelF2 = renderer.registerParts(new Parts("WF2")); //2軸
    wheelM1 = renderer.registerParts(new Parts("WM1")); //3軸
    wheelM2 = renderer.registerParts(new Parts("WM2")); //4軸
    wheelB1 = renderer.registerParts(new Parts("WB1")); //5軸
    wheelB2 = renderer.registerParts(new Parts("WB2")); //6軸


    //パンタ
    pantabase = renderer.registerParts(new Parts("panta_AB1", "panta_AB2"));
    pantaA11 = renderer.registerParts(new Parts("panta_A1_1"));
    pantaA12 = renderer.registerParts(new Parts("panta_A1_2"));
    pantaA13 = renderer.registerParts(new Parts("panta_A1_3"));
    pantaA14 = renderer.registerParts(new Parts("panta_A1_4"));
    pantaA15 = renderer.registerParts(new Parts("panta_A1_5"));
    pantaA21 = renderer.registerParts(new Parts("panta_A2_1"));
    pantaA22 = renderer.registerParts(new Parts("panta_A2_2"));
    pantaA23 = renderer.registerParts(new Parts("panta_A2_3"));
    pantaA24 = renderer.registerParts(new Parts("panta_A2_4"));
    pantaA25 = renderer.registerParts(new Parts("panta_A2_5"));
    pantaB11 = renderer.registerParts(new Parts("panta_B1_1"));
    pantaB12 = renderer.registerParts(new Parts("panta_B1_2"));
    pantaB13 = renderer.registerParts(new Parts("panta_B1_3"));
    pantaB14 = renderer.registerParts(new Parts("panta_B1_4"));
    pantaB15 = renderer.registerParts(new Parts("panta_B1_5"));
    pantaB21 = renderer.registerParts(new Parts("panta_B2_1"));
    pantaB22 = renderer.registerParts(new Parts("panta_B2_2"));
    pantaB23 = renderer.registerParts(new Parts("panta_B2_3"));
    pantaB24 = renderer.registerParts(new Parts("panta_B2_4"));
    pantaB25 = renderer.registerParts(new Parts("panta_B2_5"));
    pantaC11 = renderer.registerParts(new Parts("panta_C1_1"));
    pantaC12 = renderer.registerParts(new Parts("panta_C1_2"));
    pantaC13 = renderer.registerParts(new Parts("panta_C1_3"));
    pantaC14 = renderer.registerParts(new Parts("panta_C1_4"));
    pantaC15 = renderer.registerParts(new Parts("panta_C1_5"));
    pantaC21 = renderer.registerParts(new Parts("panta_C2_1"));
    pantaC22 = renderer.registerParts(new Parts("panta_C2_2"));
    pantaC23 = renderer.registerParts(new Parts("panta_C2_3"));
    pantaC24 = renderer.registerParts(new Parts("panta_C2_4"));
    pantaC25 = renderer.registerParts(new Parts("panta_C2_5"));
    pantaD11 = renderer.registerParts(new Parts("panta_D1_1"));
    pantaD12 = renderer.registerParts(new Parts("panta_D1_2"));
    pantaD13 = renderer.registerParts(new Parts("panta_D1_3"));
    pantaD14 = renderer.registerParts(new Parts("panta_D1_4"));
    pantaD15 = renderer.registerParts(new Parts("panta_D1_5"));
    pantaD21 = renderer.registerParts(new Parts("panta_D2_1"));
    pantaD22 = renderer.registerParts(new Parts("panta_D2_2"));
    pantaD23 = renderer.registerParts(new Parts("panta_D2_3"));
    pantaD24 = renderer.registerParts(new Parts("panta_D2_4"));
    pantaD25 = renderer.registerParts(new Parts("panta_D2_5"));

    //=== 三角関数配列 === fron 中間台車script
    sinArray = [];
    for (var i = 0; i < 6284; i++) {
        sinArray[i] = Math.sin(i / 1000);
    }
    cosArray = [];
    for (var i = 0; i < 6284; i++) {
        cosArray[i] = Math.cos(i / 1000);
    }

}

//=== 三角関数 ===
function getTri(par1, par2) {
    //getSin系が重いので配列化して参照
    //par1=sinでrad->sin、par1=Dsinでdeg->sin

    //Deg->Rad
    if (par1.match(/[Dd]/)) {
        par2 = par2 * Math.PI / 180;
    }

    //丸め
    var x = par2 % 6.284 * 1000;
    x = Math.round(x);
    x = Math.abs(x);

    var isSin = Boolean(par1.match("sin"));
    var isCos = Boolean(par1.match("cos"));

    //正負
    var isN = 1.0;
    if (par2 < 0) {
        isN = -1.0;
    }

    switch (true) {
        case isSin:
            var y = sinArray[x] * isN;
            break;
        case isCos:
            var y = cosArray[x];
            break;
        default:
            break;
    }

    return y;
}


//===== バージョン取得 =====
function MCVersionChecker() {
    var varsion = RTMCore.VERSION;
    if (varsion.indexOf("1.7.10") >= 0) return "1.7.10";
    else if (varsion.indexOf("2.0") >= 0) return "1.8.9";
    else if (varsion.indexOf("2.1") >= 0) return "1.9.4";
    else if (varsion.indexOf("2.2") >= 0) return "1.10.2";
    else if (varsion.indexOf("2.4") >= 0) return "1.12.2";
    else return "unknown";
}

//##### 号車取得 ####################
function isMiddleCar(entity) {//trueなら中間車、falseなら先頭車/後尾車
    var formation = entity.getFormation();//formation型
    if (formation == null) {//formationが取得できないときの処理
        return false;
    }
    var current = formation.getEntry(entity).entryId + 1;//この車両の号車を取得。0から数えるため+1する
    var max = formation.size();//連結してる両数を返す
    if (current == 1 || current == max) {//この車両が先頭or最後尾なら
        return false;
    }
    else {//そうでない(つまり中間)なら
        return true;
    }
}

//##### 両数取得 ####################
function isCarSize(entity) {
    var formation = entity.getFormation();//formation型
    if (formation == null) {//formationが取得できないときの処理
        return 1;
    }
    var max = formation.size();//連結してる両数を返す
    return max;
}

//##### 隣接車両取得 ####################
function isFrontNextCar(entity) {//trueなら車両前方に、falseなら車両後方に車両あり※先頭車でのみ実行
    var frontNext = entity.getConnectedTrain(0);
    if (frontNext == null) {//前方に隣接車の情報が取得できない≒前方に隣接車なし＝後方に隣接車あり
        return false;
    } else {
        return true;
    }
}

//##### render ####################
function render(entity, pass, par3) {
    //数値設定

    bogieSet = {};
    bogieSet.bd0 = 5.85; //台車間距離(中間台車は車体中央、前後台車は対称位置とする)
    bogieSet.wd0 = 1.3; //軸距÷2(前後台車)
    bogieSet.wd1 = 1.3; //軸距÷2(中間台車)
    bogieSet.wy0 = -0.45; //車輪軸Y座標(前後台車)
    bogieSet.wy1 = -0.45; //車輪軸Y座標(中間台車)

    var doorMove = 0.96, //ドア開閉距離(m)
        pantaDistance = 7.4; //パンタ中心の前後位置(m)


    GL11.glPushMatrix();

    //通常描画
    if (pass == 0) {
        body.render(renderer);
        render_bogie(entity);
        render_light(entity);
        render_HeadMark(entity);
        render_panta(entity, pantaDistance);
    }

    //半透明描画
    if (pass == 1) {
        render_door_a(entity, doorMove);
    }

    //発光部描画
    if (pass > 1) {
        body.render(renderer);
        render_light(entity);
    }

    GL11.glPopMatrix();
}

//##### render_台車 ####################
function render_bogie(entity) {

    //初期化
    var f0 = 0.0,
        bodyYaw = 0.0,
        bogieFYaw = 0.0,
        bogieBYaw = 0.0,
        bogieMYaw = 0.0,
        bodyPitch = 0.0,
        bogieFPitch = 0.0,
        bogieBPitch = 0.0,
        slideX = 0.0,
        slideY = 0.0;


    //取得
    if (entity != null && entity.getBogie(0) != null && entity.getBogie(1) != null) {
        f0 = renderer.getWheelRotationR(entity);

        bodyYaw = entity.field_70177_z;

        //前台車ヨーローカル角
        var i = entity.getBogie(0).field_70177_z - bodyYaw;
        if (i > 180) {
            bogieFYaw = i - 360;
        } else if (i < -180) {
            bogieFYaw = i + 360;
        } else {
            bogieFYaw = i;
        }
        //後台車ヨーローカル角
        var i = entity.getBogie(1).field_70177_z - bodyYaw - 180;
        if (i > 180) {
            bogieBYaw = i - 360;
        } else if (i < -180) {
            bogieBYaw = i + 360;
        } else {
            bogieBYaw = i;
        }

        //ピッチローカル角
        bodyPitch = entity.field_70125_A;
        bogieFPitch = entity.getBogie(0).field_70125_A * -1 + bodyPitch;
        bogieBPitch = entity.getBogie(1).field_70125_A + bodyPitch;

    }


    //計算
    //中台車横偏位
    var FYawR = bogieSet["bd0"] / getTri("Dsin", bogieFYaw);
    if (isFinite(FYawR)) {
        var slideXF = FYawR - FYawR * getTri("Dcos", bogieFYaw);
    } else {
        var slideXF = 0.0;
    }
    var BYawR = bogieSet["bd0"] / getTri("Dsin", bogieBYaw);
    if (isFinite(BYawR)) {
        var slideXB = BYawR - BYawR * getTri("Dcos", bogieBYaw);
    } else {
        var slideXB = 0.0;
    }
    slideX = (slideXB - slideXF) / 2;

    //中台車縦偏位
    var FPitchR = bogieSet["bd0"] / getTri("Dsin", bogieFPitch);
    if (isFinite(FPitchR)) {
        var slideYF = FPitchR - FPitchR * getTri("Dcos", bogieFPitch);
    } else {
        var slideYF = 0.0;
    }
    var BPitchR = bogieSet["bd0"] / getTri("Dsin", bogieBPitch);
    if (isFinite(BPitchR)) {
        var slideYB = BPitchR - BPitchR * getTri("Dcos", bogieBPitch);
    } else {
        var slideYB = 0.0;
    }
    slideY = (slideYF - slideYB) / 2;

    //中台車ヨー回転
    bogieMYaw = (bogieFYaw + bogieBYaw) * -0.5;


    //表示
    //前台車
    GL11.glPushMatrix();
    renderer.rotate(bogieFYaw, 'Y', 0.0, 0.0, bogieSet["bd0"]);
    renderer.rotate(bogieFPitch, 'X', 0.0, 0.0, bogieSet["bd0"]);
    bogieF.render(renderer);
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], bogieSet["bd0"] + bogieSet["wd0"]);
    wheelF1.render(renderer);
    GL11.glPopMatrix();
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], bogieSet["bd0"] - bogieSet["wd0"]);
    wheelF2.render(renderer);
    GL11.glPopMatrix();
    GL11.glPopMatrix();

    //中台車
    GL11.glPushMatrix();
    GL11.glTranslatef(slideX, slideY, 0.0);
    renderer.rotate(bogieMYaw, 'Y', 0.0, 0.0, 0.0);
    bogieM.render(renderer);
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy1"], bogieSet["wd1"]);
    wheelM1.render(renderer);
    GL11.glPopMatrix();
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy1"], -bogieSet["wd1"]);
    wheelM2.render(renderer);
    GL11.glPopMatrix();
    GL11.glPopMatrix();

    //後台車
    GL11.glPushMatrix();
    renderer.rotate(bogieBYaw, 'Y', 0.0, 0.0, -bogieSet["bd0"]);
    renderer.rotate(bogieBPitch, 'X', 0.0, 0.0, -bogieSet["bd0"]);
    bogieB.render(renderer);
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], -bogieSet["bd0"] + bogieSet["wd0"]);
    wheelB1.render(renderer);
    GL11.glPopMatrix();
    GL11.glPushMatrix();
    renderer.rotate(f0, 'X', 0.0, bogieSet["wy0"], -bogieSet["bd0"] - bogieSet["wd0"]);
    wheelB2.render(renderer);
    GL11.glPopMatrix();
    GL11.glPopMatrix();
}

//##### render_ライト ####################
function render_light(entity) {

    var varsion = MCVersionChecker();
    var st11 = 0; //方向幕の一番上から普通幕の終わりまでのコマ数

    if (entity != null) {
        var form = isMiddleCar(entity);
        var Fnext = isFrontNextCar(entity);
        var max = isCarSize(entity);
    }



    if (entity != null) {
        if (varsion == "1.7.10" || varsion == "1.8.9" || varsion == "1.9.4") {
            var st0 = entity.getTrainStateData(0); //進行方向
            var st11 = entity.getTrainStateData(11); //車内灯
        } else {
            var st0 = entity.getVehicleState(TrainState.getStateType(0)); //進行方向
            var st11 = entity.getVehicleState(TrainState.getStateType(11)); //チャンクローダー
        }
    }

    if (max > 1) {//単行でないとき
        if (form == false) {//編成両端であるとき
            if (Fnext == false) {//自車後方にほかの車両があるとき
                if (st0 == 0) {//前方に進むとき(=進行方向最前)
                    GL11.glPushMatrix();

                    F_Fon.render(renderer);
                    F_Bof.render(renderer);
                    B_Fof.render(renderer);
                    B_Bof.render(renderer);


                    GL11.glPopMatrix();
                } else {//後方に進むとき(=進行方向最後)
                    GL11.glPushMatrix();

                    F_Fof.render(renderer);
                    F_Bon.render(renderer);
                    B_Fof.render(renderer);
                    B_Bof.render(renderer);

                    GL11.glPopMatrix();
                }
            } else {//自車前方にほかの車両があるとき
                if (st0 == 0) {//前方に進むとき(=進行方向最後)
                    GL11.glPushMatrix();

                    F_Fof.render(renderer);
                    F_Bof.render(renderer);
                    B_Fof.render(renderer);
                    B_Bon.render(renderer);


                    GL11.glPopMatrix();
                } else {//後方に進むとき(=進行方向最前)
                    GL11.glPushMatrix();

                    F_Fof.render(renderer);
                    F_Bof.render(renderer);
                    B_Fon.render(renderer);
                    B_Bof.render(renderer);


                    GL11.glPopMatrix();
                }
            }
        } else {//編成中間であるとき
            GL11.glPushMatrix();

            F_Fof.render(renderer);
            F_Bof.render(renderer);
            B_Fof.render(renderer);
            B_Bof.render(renderer);


            GL11.glPopMatrix();
        }
    } else {//単行であるとき
        if (st0 == 0) {//前方に進むとき
            GL11.glPushMatrix();

            F_Bof.render(renderer);
            B_Fof.render(renderer);

            if (st11 == 1) {//チャンクローダー1で入換灯
                ire.render(renderer);
            } else {//それ以外
                F_Fon.render(renderer);
                B_Bon.render(renderer);
            }

            GL11.glPopMatrix();
        } else {//後方に進むとき
            GL11.glPushMatrix();

            F_Fof.render(renderer);
            B_Bof.render(renderer);

            if (st11 == 1) {//チャンクローダー1で入換灯
                ire.render(renderer);
            } else {//それ以外
                F_Bon.render(renderer);
                B_Fon.render(renderer);
            }

            GL11.glPopMatrix();
        }
    }

}

//##### render_パンタ ####################
function render_panta(entity, pantaDistance) {
    pantabase.render(renderer);
    var CB1 = entity == null ? 0 : entity.getResourceState().getDataMap().getInt("Button0");
    var CB2 = entity == null ? 0 : entity.getResourceState().getDataMap().getInt("Button1");
    //カスタムボタンを取得
    //三項演算子でぬるぽ弾きもしてる



    var pantaState = 1.0,
        pDis = pantaDistance;



    if (CB2 == 0) {
        if (CB1 == 0) {//パンタ下げ
            var FpBro1 = pantaState * 22,
                FpBro2 = pantaState * 57,
                BpBro1 = pantaState * 22,
                BpBro2 = pantaState * 57;


            //パンタB1
            GL11.glPushMatrix();
            renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
            pantaB11.render(renderer);
            renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
            pantaB12.render(renderer);
            renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
            pantaB13.render(renderer);
            GL11.glPopMatrix();
            GL11.glPushMatrix();
            renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
            pantaB14.render(renderer);
            renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
            pantaB15.render(renderer);
            GL11.glPopMatrix();

            //パンタB2
            GL11.glPushMatrix();
            renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
            pantaB21.render(renderer);
            renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
            pantaB22.render(renderer);
            renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
            pantaB23.render(renderer);
            GL11.glPopMatrix();
            GL11.glPushMatrix();
            renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
            pantaB24.render(renderer);
            renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
            pantaB25.render(renderer);
            GL11.glPopMatrix();

        } else {
            if (CB1 == 1) {//パンタ1エンド(w51)

                var FpBro1 = pantaState * 11,
                    FpBro2 = pantaState * 27,
                    BpBro1 = pantaState * 22,
                    BpBro2 = pantaState * 57;



                //パンタB1
                GL11.glPushMatrix();
                renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
                pantaB11.render(renderer);
                renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
                pantaB12.render(renderer);
                renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
                pantaB13.render(renderer);
                GL11.glPopMatrix();
                GL11.glPushMatrix();
                renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
                pantaB14.render(renderer);
                renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
                pantaB15.render(renderer);
                GL11.glPopMatrix();

                //パンタB2
                GL11.glPushMatrix();
                renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
                pantaB21.render(renderer);
                renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
                pantaB22.render(renderer);
                renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
                pantaB23.render(renderer);
                GL11.glPopMatrix();
                GL11.glPushMatrix();
                renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
                pantaB24.render(renderer);
                renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
                pantaB25.render(renderer);
                GL11.glPopMatrix();
            } else {
                if (CB1 == 2) {//パンタ2エンド(w51)

                    var FpBro1 = pantaState * 22,
                        FpBro2 = pantaState * 57,
                        BpBro1 = pantaState * 11,
                        BpBro2 = pantaState * 27;



                    //パンタB1
                    GL11.glPushMatrix();
                    renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
                    pantaB11.render(renderer);
                    renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
                    pantaB12.render(renderer);
                    renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
                    pantaB13.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
                    pantaB14.render(renderer);
                    renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
                    pantaB15.render(renderer);
                    GL11.glPopMatrix();

                    //パンタB2
                    GL11.glPushMatrix();
                    renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
                    pantaB21.render(renderer);
                    renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
                    pantaB22.render(renderer);
                    renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
                    pantaB23.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
                    pantaB24.render(renderer);
                    renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
                    pantaB25.render(renderer);
                    GL11.glPopMatrix();
                } else {//パンタ両エンド(w51)
                    var FpBro1 = pantaState * 11,
                        FpBro2 = pantaState * 27,
                        BpBro1 = pantaState * 11,
                        BpBro2 = pantaState * 27;//16?



                    //パンタB1
                    GL11.glPushMatrix();
                    renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
                    pantaB11.render(renderer);
                    renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
                    pantaB12.render(renderer);
                    renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
                    pantaB13.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
                    pantaB14.render(renderer);
                    renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
                    pantaB15.render(renderer);
                    GL11.glPopMatrix();

                    //パンタB2
                    GL11.glPushMatrix();
                    renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
                    pantaB21.render(renderer);
                    renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
                    pantaB22.render(renderer);
                    renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
                    pantaB23.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
                    pantaB24.render(renderer);
                    renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
                    pantaB25.render(renderer);
                    GL11.glPopMatrix();
                }
            }
        }
    } else {
        if (CB1 == 0) {
            var FpBro1 = pantaState * 22,
                FpBro2 = pantaState * 57,
                BpBro1 = pantaState * 22,
                BpBro2 = pantaState * 57;



            //パンタB1
            GL11.glPushMatrix();
            renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
            pantaB11.render(renderer);
            renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
            pantaB12.render(renderer);
            renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
            pantaB13.render(renderer);
            GL11.glPopMatrix();
            GL11.glPushMatrix();
            renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
            pantaB14.render(renderer);
            renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
            pantaB15.render(renderer);
            GL11.glPopMatrix();

            //パンタB2
            GL11.glPushMatrix();
            renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
            pantaB21.render(renderer);
            renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
            pantaB22.render(renderer);
            renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
            pantaB23.render(renderer);
            GL11.glPopMatrix();
            GL11.glPushMatrix();
            renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
            pantaB24.render(renderer);
            renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
            pantaB25.render(renderer);
            GL11.glPopMatrix();

        } else {
            if (CB1 == 1) {

                var FpBro1 = pantaState * 0,
                    FpBro2 = pantaState * 0,
                    BpBro1 = pantaState * 22,
                    BpBro2 = pantaState * 57;



                //パンタB1
                GL11.glPushMatrix();
                renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
                pantaB11.render(renderer);
                renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
                pantaB12.render(renderer);
                renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
                pantaB13.render(renderer);
                GL11.glPopMatrix();
                GL11.glPushMatrix();
                renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
                pantaB14.render(renderer);
                renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
                pantaB15.render(renderer);
                GL11.glPopMatrix();

                //パンタB2
                GL11.glPushMatrix();
                renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
                pantaB21.render(renderer);
                renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
                pantaB22.render(renderer);
                renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
                pantaB23.render(renderer);
                GL11.glPopMatrix();
                GL11.glPushMatrix();
                renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
                pantaB24.render(renderer);
                renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
                pantaB25.render(renderer);
                GL11.glPopMatrix();
            } else {
                if (CB1 == 2) {

                    var FpBro1 = pantaState * 22,
                        FpBro2 = pantaState * 57,
                        BpBro1 = pantaState * 0,
                        BpBro2 = pantaState * 0;



                    //パンタB1
                    GL11.glPushMatrix();
                    renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
                    pantaB11.render(renderer);
                    renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
                    pantaB12.render(renderer);
                    renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
                    pantaB13.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
                    pantaB14.render(renderer);
                    renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
                    pantaB15.render(renderer);
                    GL11.glPopMatrix();

                    //パンタB2
                    GL11.glPushMatrix();
                    renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
                    pantaB21.render(renderer);
                    renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
                    pantaB22.render(renderer);
                    renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
                    pantaB23.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
                    pantaB24.render(renderer);
                    renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
                    pantaB25.render(renderer);
                    GL11.glPopMatrix();
                } else {
                    var FpBro1 = pantaState * 0,
                        FpBro2 = pantaState * 0,
                        BpBro1 = pantaState * 0,
                        BpBro2 = pantaState * 0;


                    //パンタB1
                    GL11.glPushMatrix();
                    renderer.rotate(FpBro1, 'X', 0.0, 3.0784, pDis - 0.5224);
                    pantaB11.render(renderer);
                    renderer.rotate(-FpBro2, 'X', 0.0, 3.8916, pDis + 0.9603);
                    pantaB12.render(renderer);
                    renderer.rotate(FpBro2 - FpBro1, 'X', 0.0, 4.6227, pDis + 0.0229);
                    pantaB13.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-FpBro1, 'X', 0.0, 3.0784, pDis + 0.5224);
                    pantaB14.render(renderer);
                    renderer.rotate(FpBro2, 'X', 0.0, 3.8916, pDis - 0.9603);
                    pantaB15.render(renderer);
                    GL11.glPopMatrix();

                    //パンタB2
                    GL11.glPushMatrix();
                    renderer.rotate(BpBro1, 'X', 0.0, 3.0784, -pDis - 0.5224);
                    pantaB21.render(renderer);
                    renderer.rotate(-BpBro2, 'X', 0.0, 3.8916, -pDis + 0.9603);
                    pantaB22.render(renderer);
                    renderer.rotate(BpBro2 - BpBro1, 'X', 0.0, 4.6227, -pDis + 0.0229);
                    pantaB23.render(renderer);
                    GL11.glPopMatrix();
                    GL11.glPushMatrix();
                    renderer.rotate(-BpBro1, 'X', 0.0, 3.0784, -pDis + 0.5224);
                    pantaB24.render(renderer);
                    renderer.rotate(BpBro2, 'X', 0.0, 3.8916, -pDis - 0.9603);
                    pantaB25.render(renderer);
                    GL11.glPopMatrix();
                }
            }
        }

    }
}

//##### render_ヘッドマーク ####################
function render_HeadMark(entity) {
    pantabase.render(renderer);
    var CB3 = entity == null ? 0 : entity.getResourceState().getDataMap().getInt("Button2");//1エンドヘッドマーク
    var CB4 = entity == null ? 0 : entity.getResourceState().getDataMap().getInt("Button3");//2エンドヘッドマーク
    //カスタムボタンを取得
    //三項演算子でぬるぽ弾きもしてる


    switch (CB3) {
        case 0:
            GL11.glPushMatrix();
            HM10.render(renderer);
            GL11.glPopMatrix();
            break;
        case 1:
            GL11.glPushMatrix();
            HM11.render(renderer);
            GL11.glPopMatrix();
            break;
        case 2:
            GL11.glPushMatrix();
            HM12.render(renderer);
            GL11.glPopMatrix();
            break;
    }
    switch (CB4) {
        case 0:
            GL11.glPushMatrix();
            HM20.render(renderer);
            GL11.glPopMatrix();
            break;
        case 1:
            GL11.glPushMatrix();
            HM21.render(renderer);
            GL11.glPopMatrix();
            break;
        case 2:
            GL11.glPushMatrix();
            HM22.render(renderer);
            GL11.glPopMatrix();
            break;
    }

}

